> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# Create Payment Method

POST https://api.npretail.app/{tenant}/{environment}/{company}/account/{accountId}/paymentMethod
Content-Type: application/json

Reference: https://docs.navipartner.com/apis/api-reference/accounts/service-account-payment-method/create-payment-method

## Authentication

- `x-np-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `tenant` (string, required) — Your Entra Tenant ID. [More details.](/paths#1-tenant)
- `environment` (string, required) — Your Business Central Environment. [More details.](/paths#2-environment)
- `company` (string, required) — Your Business Central Company. [More details.](/paths#3-company)
- `accountId` (UUID, required)

### Body (application/json)

This endpoint expects an AccountPaymentMethodCreateRequestDTO.

- `PSP` (enum, required) — The payment service provider of the payment method.
  - Allowed values: `Adyen`, `Vipps`
- `maskedPAN` (string, required) — The masked PAN of the card. The exact structure depends on the PSP.
- `PANLastDigits` (string, required) — The last 4 digits of the payment card number.
- `paymentToken` (string, required) — The shopper reference of the payment method.
- `paymentInstrument` (string, optional) — The payment method type.
- `paymentBrand` (string, optional) — The payment method brand.
- `expiryDate` (date, optional) — The expiry date of the card.
- `alias` (string, optional) — A short description that can be assigned to each payment method by the end user.
- `shopperReference` (string, optional) — The shopper reference of the payment method.
- `membershipIds` (list of UUID, optional) — Specifies which membership IDs the payment method should be applied to.

## Response

### 201

- `id` (UUID, required) — Unique identifier for a payment method.
- `PANLastDigits` (string, optional) — The last 4 digits of the payment card number.
- `PSP` (enum, optional) — The payment service provider of the payment method.
  - Allowed values: `Adyen`, `Vipps`
- `alias` (string, optional) — A short description that can be assigned to each payment method by the end user.
- `default` (boolean, optional) — Indicates whether the payment method should be set up as default.
- `expiryDate` (date, optional) — The expiry date of the card.
- `maskedPAN` (string, optional) — The masked PAN of the card. The exact structure depends on the PSP.
- `paymentBrand` (string, optional) — The payment method brand.
- `paymentInstrument` (string, optional) — The payment method type.
- `paymentToken` (string, optional) — The shopper reference of the payment method.
- `shopperReference` (string, optional) — The shopper reference of the payment method.
- `status` (enum, optional) — The status of the payment method.
  - Allowed values: `Active`, `Archived`

## Examples

**Request**

```json
{
  "PSP": "Adyen",
  "maskedPAN": "541333 **** 1234",
  "PANLastDigits": "1234",
  "paymentToken": "FMF7KDR3WL9S2DK5",
  "paymentInstrument": "Card",
  "paymentBrand": "visa",
  "expiryDate": "2029-09-30",
  "alias": "",
  "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
  "membershipIds": [
    "4296c7dd-dfb9-47bc-b446-5f23d51900ab",
    "14b4c9fd-4f91-42c2-a251-9ae8bed91a62"
  ]
}
```

**Response**

```json
{
  "id": "a7b41af8-d187-48d9-89e0-a57c47039004",
  "PANLastDigits": "1234",
  "PSP": "Adyen",
  "alias": "",
  "default": false,
  "expiryDate": "2029-09-30",
  "maskedPAN": "541333 **** 1234",
  "paymentBrand": "visa",
  "paymentInstrument": "Card",
  "paymentToken": "FMF7KDR3WL9S2DK5",
  "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
  "status": "Active"
}
```

**SDK Code**

```python Create Payment Method
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./account/e2cfea9f-385e-4d83-8b50-42256885b03a/paymentMethod"

payload = {
    "PSP": "Adyen",
    "maskedPAN": "541333 **** 1234",
    "PANLastDigits": "1234",
    "paymentToken": "FMF7KDR3WL9S2DK5",
    "paymentInstrument": "Card",
    "paymentBrand": "visa",
    "expiryDate": "2029-09-30",
    "alias": "",
    "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
    "membershipIds": ["4296c7dd-dfb9-47bc-b446-5f23d51900ab", "14b4c9fd-4f91-42c2-a251-9ae8bed91a62"]
}
headers = {
    "x-np-api-key": "<NaviPartner API Key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create Payment Method
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./account/e2cfea9f-385e-4d83-8b50-42256885b03a/paymentMethod';
const options = {
  method: 'POST',
  headers: {'x-np-api-key': '<NaviPartner API Key>', 'Content-Type': 'application/json'},
  body: '{"PSP":"Adyen","maskedPAN":"541333 **** 1234","PANLastDigits":"1234","paymentToken":"FMF7KDR3WL9S2DK5","paymentInstrument":"Card","paymentBrand":"visa","expiryDate":"2029-09-30","alias":"","shopperReference":"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895","membershipIds":["4296c7dd-dfb9-47bc-b446-5f23d51900ab","14b4c9fd-4f91-42c2-a251-9ae8bed91a62"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create Payment Method
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./account/e2cfea9f-385e-4d83-8b50-42256885b03a/paymentMethod"

	payload := strings.NewReader("{\n  \"PSP\": \"Adyen\",\n  \"maskedPAN\": \"541333 **** 1234\",\n  \"PANLastDigits\": \"1234\",\n  \"paymentToken\": \"FMF7KDR3WL9S2DK5\",\n  \"paymentInstrument\": \"Card\",\n  \"paymentBrand\": \"visa\",\n  \"expiryDate\": \"2029-09-30\",\n  \"alias\": \"\",\n  \"shopperReference\": \"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895\",\n  \"membershipIds\": [\n    \"4296c7dd-dfb9-47bc-b446-5f23d51900ab\",\n    \"14b4c9fd-4f91-42c2-a251-9ae8bed91a62\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create Payment Method
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./account/e2cfea9f-385e-4d83-8b50-42256885b03a/paymentMethod")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"PSP\": \"Adyen\",\n  \"maskedPAN\": \"541333 **** 1234\",\n  \"PANLastDigits\": \"1234\",\n  \"paymentToken\": \"FMF7KDR3WL9S2DK5\",\n  \"paymentInstrument\": \"Card\",\n  \"paymentBrand\": \"visa\",\n  \"expiryDate\": \"2029-09-30\",\n  \"alias\": \"\",\n  \"shopperReference\": \"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895\",\n  \"membershipIds\": [\n    \"4296c7dd-dfb9-47bc-b446-5f23d51900ab\",\n    \"14b4c9fd-4f91-42c2-a251-9ae8bed91a62\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Create Payment Method
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./account/e2cfea9f-385e-4d83-8b50-42256885b03a/paymentMethod")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"PSP\": \"Adyen\",\n  \"maskedPAN\": \"541333 **** 1234\",\n  \"PANLastDigits\": \"1234\",\n  \"paymentToken\": \"FMF7KDR3WL9S2DK5\",\n  \"paymentInstrument\": \"Card\",\n  \"paymentBrand\": \"visa\",\n  \"expiryDate\": \"2029-09-30\",\n  \"alias\": \"\",\n  \"shopperReference\": \"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895\",\n  \"membershipIds\": [\n    \"4296c7dd-dfb9-47bc-b446-5f23d51900ab\",\n    \"14b4c9fd-4f91-42c2-a251-9ae8bed91a62\"\n  ]\n}")
  .asString();
```

```php Create Payment Method
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./account/e2cfea9f-385e-4d83-8b50-42256885b03a/paymentMethod', [
  'body' => '{
  "PSP": "Adyen",
  "maskedPAN": "541333 **** 1234",
  "PANLastDigits": "1234",
  "paymentToken": "FMF7KDR3WL9S2DK5",
  "paymentInstrument": "Card",
  "paymentBrand": "visa",
  "expiryDate": "2029-09-30",
  "alias": "",
  "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
  "membershipIds": [
    "4296c7dd-dfb9-47bc-b446-5f23d51900ab",
    "14b4c9fd-4f91-42c2-a251-9ae8bed91a62"
  ]
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp Create Payment Method
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./account/e2cfea9f-385e-4d83-8b50-42256885b03a/paymentMethod");
var request = new RestRequest(Method.POST);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"PSP\": \"Adyen\",\n  \"maskedPAN\": \"541333 **** 1234\",\n  \"PANLastDigits\": \"1234\",\n  \"paymentToken\": \"FMF7KDR3WL9S2DK5\",\n  \"paymentInstrument\": \"Card\",\n  \"paymentBrand\": \"visa\",\n  \"expiryDate\": \"2029-09-30\",\n  \"alias\": \"\",\n  \"shopperReference\": \"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895\",\n  \"membershipIds\": [\n    \"4296c7dd-dfb9-47bc-b446-5f23d51900ab\",\n    \"14b4c9fd-4f91-42c2-a251-9ae8bed91a62\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create Payment Method
import Foundation

let headers = [
  "x-np-api-key": "<NaviPartner API Key>",
  "Content-Type": "application/json"
]
let parameters = [
  "PSP": "Adyen",
  "maskedPAN": "541333 **** 1234",
  "PANLastDigits": "1234",
  "paymentToken": "FMF7KDR3WL9S2DK5",
  "paymentInstrument": "Card",
  "paymentBrand": "visa",
  "expiryDate": "2029-09-30",
  "alias": "",
  "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
  "membershipIds": ["4296c7dd-dfb9-47bc-b446-5f23d51900ab", "14b4c9fd-4f91-42c2-a251-9ae8bed91a62"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./account/e2cfea9f-385e-4d83-8b50-42256885b03a/paymentMethod")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```